﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Configuration;
using System.IO;
using System.Net;
namespace DemoApplication
{
    public partial class frmContourlines : Form
    {
        public frmContourlines()
        {
            InitializeComponent();
        }
       
       
        private void LoadContor()
        {
            try
            {
                ValueStyle vcontour = new ValueStyle();
                vcontour.ColumnName = "ELEVft";

                ValueItem v500 = new ValueItem();
                v500.Value = "500";
                v500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#CCEB85"), (float)0.05));

                ValueItem v1000 = new ValueItem();
                v1000.Value = "1000";
                v1000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#B2E07A"), (float)0.05));

                ValueItem v1500 = new ValueItem();
                v1500.Value = "1500";
                v1500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#99D670"), (float)0.05));

                ValueItem v2000 = new ValueItem();
                v2000.Value = "2000";
                v2000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#80CC66"), (float)0.05));

                ValueItem v2500 = new ValueItem();
                v2500.Value = "2500";
                v2500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#73C761"), (float)0.05));

                ValueItem v3000 = new ValueItem();
                v3000.Value = "3000";
                v3000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#60BF59"), (float)0.05));

                ValueItem v3500 = new ValueItem();
                v3500.Value = "3500";
                v3500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#4DB852"), (float)0.05));

                ValueItem v4000 = new ValueItem();
                v4000.Value = "4000";
                v4000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#3AB04A"), (float)0.05));

                ValueItem v4500 = new ValueItem();
                v4500.Value = "4500";
                v4500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#13A13B"), (float)0.05));

                ValueItem v5000 = new ValueItem();
                v5000.Value = "5000";
                v5000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#006600"), (float)0.05));
                
                ValueItem v5500 = new ValueItem();
                v5500.Value = "5500";
                v5500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#807900"), (float)0.05));

                ValueItem v6000 = new ValueItem();
                v6000.Value = "6000";
                v6000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#997D00"), (float)0.05));

                ValueItem v6500 = new ValueItem();
                v6500.Value = "6500";
                v6500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#B28100"), (float)0.05));

                ValueItem v7000 = new ValueItem();
                v7000.Value = "7000";
                v7000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#CC8400"), (float)0.05));

                ValueItem v7500 = new ValueItem();
                v7500.Value = "7500";
                v7500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#E68800"), (float)0.05));

                ValueItem v8000 = new ValueItem();
                v8000.Value = "8000";
                v8000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF9900"), (float)0.05));

                ValueItem v8500 = new ValueItem();
                v8500.Value = "8500";
                v8500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF8500"), (float)0.05));

                ValueItem v9000 = new ValueItem();
                v9000.Value = "9000";
                v9000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF7E00"), (float)0.05));

                ValueItem v9500 = new ValueItem();
                v9500.Value = "9500";
                v9500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF7000"), (float)0.05));

                ValueItem v10000 = new ValueItem();
                v10000.Value = "10000";
                v10000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF6900"), (float)0.05));

                ValueItem v10500 = new ValueItem();
                v10500.Value = "10500";
                v10500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF6200"), (float)0.05));

                ValueItem v11000 = new ValueItem();
                v11000.Value = "11000";
                v11000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF5B00"), (float)0.05));

                ValueItem v11500 = new ValueItem();
                v11500.Value = "11500";
                v11500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF5400"), (float)0.05));

                ValueItem v12000 = new ValueItem();
                v12000.Value = "12000";
                v12000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF4D00"), (float)0.05));

                ValueItem v12500 = new ValueItem();
                v12500.Value = "12500";
                v12500.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF4600"), (float)0.05));

                ValueItem v13000 = new ValueItem();
                v13000.Value = "13000";
                v13000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v14000 = new ValueItem();
                v14000.Value = "14000";
                v14000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v15000 = new ValueItem();
                v15000.Value = "15000";
                v15000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v16000 = new ValueItem();
                v16000.Value = "16000";
                v16000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v17000 = new ValueItem();
                v17000.Value = "17000";
                v17000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));


                ValueItem v18000 = new ValueItem();
                v18000.Value = "18000";
                v18000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v19000 = new ValueItem();
                v19000.Value = "19000";
                v19000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v20000 = new ValueItem();
                v20000.Value = "20000";
                v20000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v21000 = new ValueItem();
                v21000.Value = "21000";
                v21000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v22000 = new ValueItem();
                v22000.Value = "22000";
                v22000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v23000 = new ValueItem();
                v23000.Value = "23000";
                v23000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v24000 = new ValueItem();
                v24000.Value = "24000";
                v24000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v25000 = new ValueItem();
                v25000.Value = "25000";
                v25000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v26000 = new ValueItem();
                v26000.Value = "26000";
                v26000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v27000 = new ValueItem();
                v27000.Value = "27000";
                v27000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                ValueItem v28000 = new ValueItem();
                v28000.Value = "28000";
                v28000.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.FromHtml("#FF0000"), (float)0.05));

                vcontour.ValueItems.Add(v500);
                vcontour.ValueItems.Add(v1000);
                vcontour.ValueItems.Add(v1500);
                vcontour.ValueItems.Add(v2000);
                vcontour.ValueItems.Add(v2500);
                vcontour.ValueItems.Add(v3000);
                vcontour.ValueItems.Add(v3500);
                vcontour.ValueItems.Add(v4000);
                vcontour.ValueItems.Add(v4500);
                vcontour.ValueItems.Add(v5000);
                vcontour.ValueItems.Add(v5500);
                vcontour.ValueItems.Add(v6000);
                vcontour.ValueItems.Add(v6500);
                vcontour.ValueItems.Add(v7000);
                vcontour.ValueItems.Add(v7500);
                vcontour.ValueItems.Add(v8000);
                vcontour.ValueItems.Add(v8500);
                vcontour.ValueItems.Add(v9000);
                vcontour.ValueItems.Add(v9500);
                vcontour.ValueItems.Add(v10000);
                vcontour.ValueItems.Add(v10500);
                vcontour.ValueItems.Add(v11000);
                vcontour.ValueItems.Add(v11500);
                vcontour.ValueItems.Add(v12000);
                vcontour.ValueItems.Add(v12500);
                vcontour.ValueItems.Add(v13000);
                vcontour.ValueItems.Add(v14000);
                vcontour.ValueItems.Add(v15000);
                vcontour.ValueItems.Add(v16000);
                vcontour.ValueItems.Add(v17000);
                vcontour.ValueItems.Add(v18000);
                vcontour.ValueItems.Add(v19000);
                vcontour.ValueItems.Add(v20000);
                vcontour.ValueItems.Add(v21000);
                vcontour.ValueItems.Add(v22000);
                vcontour.ValueItems.Add(v23000);
                vcontour.ValueItems.Add(v24000);
                vcontour.ValueItems.Add(v25000);
                vcontour.ValueItems.Add(v26000);
                vcontour.ValueItems.Add(v27000);
                vcontour.ValueItems.Add(v28000);


                TextStyle tc =  new TextStyle("ELEVft", new GeoFont("Arial", (float)6.5), new GeoSolidBrush(GeoColor.SimpleColors.Black));
                tc.TextLineSegmentRatio = double.MaxValue;
                
                tc.SplineType = SplineType.StandardSplining;

                //ShapeFileFeatureLayer scontour = new ShapeFileFeatureLayer("C:\\Data\\Projects\\FPDSV2.0\\ArmsFP\\ArmsLoginGUI\\bin\\Release\\MapData\\Dems\\500\\19N-37N-084E-101E.shp");
                ShapeFileFeatureLayer scontour = new ShapeFileFeatureLayer(Application.StartupPath+@"\Data\19N-37N-066E-084E.shp");
                //scontour.RequireIndex = false;
                ShapeFileFeatureLayer.BuildIndexFile(Application.StartupPath + @"\Data\19N-37N-066E-084E.shp", Application.StartupPath + @"\Data\19N-37N-066E-084E.idx", BuildIndexMode.DoNotRebuild);
                
                scontour.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(vcontour);
                scontour.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(tc);
                scontour.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                LayerOverlay lcontour = new LayerOverlay();
                lcontour.Layers.Add(scontour);
                wfMap.Overlays.Add(lcontour);
            }
            catch (Exception er)
            {
                MessageBox.Show(er.ToString());
            }
        }
        private void LoadDefaultMap()
        {
            try
            {
                wfMap.Overlays.Clear();
                wfMap.MapUnit = GeographyUnit.DecimalDegree;
                wfMap.ZoomLevelSnapping = ZoomLevelSnappingMode.None;
                GraticuleAdornmentLayer graticuleAdornmentLayer = new GraticuleAdornmentLayer();
                graticuleAdornmentLayer.Close();
                graticuleAdornmentLayer.Open();
                graticuleAdornmentLayer.GraticuleLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Silver, 0.001F, LineDashStyle.Dash, false);

                wfMap.AdornmentOverlay.Layers.Add("graticule", graticuleAdornmentLayer);
               
               // wfMap.CurrentExtent = new RectangleShape(71, 8, 74, -9);
                wfMap.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);
                ShapeFileFeatureLayer worldLayer1 = new ShapeFileFeatureLayer(Application.StartupPath + @"\Data\Countries02.shp");
                worldLayer1.DrawingQuality = DrawingQuality.HighQuality;
                worldLayer1.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 213, 213, 170)); 
                worldLayer1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                LayerOverlay coverlay = new LayerOverlay();

                coverlay.Layers.Add("CountryLayer", worldLayer1);
                wfMap.Overlays.Add(coverlay);
                wfMap.FindFeatureLayer("CountryLayer").Open();
                wfMap.CurrentExtent = wfMap.FindFeatureLayer("CountryLayer").GetBoundingBox();

                //LoadClosedContour();
                LoadContor();
              
                wfMap.Refresh();

            }
            catch (Exception err)
            {
                MessageBox.Show(err.Message, "");
            }
        }
        string StrPath = Application.StartupPath;
       
        private Dictionary<PointShape, double> wellDepthPointData;


        private void frmContourlines_Load(object sender, EventArgs e)
        {
        
           // CreateIndex();
            LoadDefaultMap();
           
        }
        private void CreateIndex()
        {
            string[] filename = Directory.GetFiles("D:\\testpolygon\\merge");
            for (int i = 0; i < filename.Length; i++)
            {
                if (filename[i].ToString() == "D:\\testpolygon\\merge\\01N-19N-066E-084E.shp")
                {
                    //ShapeFileFeatureLayer s = new ShapeFileFeatureLayer("C:\\Data\\Projects\\FPDSV2.0\\ArmsFP\\ArmsLoginGUI\\bin\\Release\\MapData\\Dems\\500\\" + filename[i].ToString());
                    string ifilename = "D:\\testpolygon\\merge\\01N-19N-066E-084E.ids";
                    ShapeFileFeatureLayer.BuildIndexFile(filename[i].ToString());
                }
            }
        }
      
       
        
    }
}
